/* control_box.cc - Test the ability to "grab" a force and manipulate.
        This would be a good way to implement user control.
*/

#include <stdio.h>
#include "physics.h"

int main(void)
{
	universe* Everything = new universe;
	
	// earth
	Everything->add(5.93e24,
	                  ToVector(-6.37e6, 0.0 ,0.0));
	
	// ball
	object_id Ball = Everything->add(10.0, ToVector(50.0, 0.0, 0.0));
	
	object_control Ball_Handle = Everything->control(Ball);
	
	// apply 50 N force in Y dir.
	if (Ball_Handle.setForce(ToVector(0, 50.0, 0))) {
		printf("setForce OK\n");
	} else {
		printf("setForce failed\n");
	}
	
	scalar* Result = Everything->acceleration(Ball).array();
	
        printf("a = (%g %g %g)\n", Result[0], Result[1], Result[2]);
        Everything->position(Ball).array();
		
	while (Result[1] < 50.0) {
		printf("%.3f\t\t%.3f\r", Result[0], Result[1]);
		Everything->position(Ball).array();
	}
	
	printf("\n");
        Ball_Handle.setForce(-(Ball_Handle.forceIs()));
	
	while (Result[1] > 0.0) {
		printf("%.3f\t\t%.3f\r", Result[0], Result[1]);
		Everything->position(Ball).array();
	}

	printf("\n");
	return 0;
}