// drop.cc  -- a little test program, just to see if the objects work at
// all.

#include <stdio.h>
#include "object.h"
#include <math.h>

int main(void)
{
	fprintf(stderr, "Creating object:");
	object Ball("ball", 10.0, ToVector(50.0, 0.0, 0.0));
	fprintf(stderr, ".\n");
	
	
	if (Ball.pause()) {
		fprintf(stderr, "paused.\n");
	} else {
		fprintf(stderr, "not paused.\n");
	}
	
	fprintf(stderr, "mass = %g\n", Ball.mass());

		
	fprintf(stderr, "Applying force:");
	force_id Gravity = Ball.applyForce(ToVector(-98.0, 0.0, 0.0));
	fprintf(stderr, ".\n");
	vector y = Ball.acceleration();
	fprintf(stderr, "a = %g, %g, %g\n",  y.x(), y.y(), y.z());
	
	fprintf(stderr, "Recording time:");
	scalar old_T = Ball.time();
	fprintf(stderr, ".\n");
	scalar X = Ball.position().x();
	while (X > 0.0) {
		printf("%s\t%g\r", Ball.name(), X);
		X = Ball.position().x();
	}
	
	scalar new_T = Ball.time();
	
	printf("\nThat took: %g seconds.\n", new_T - old_T);
	printf("(physics says %g.)\n", sqrt(2*50./9.8));
	fprintf(stderr, "Reversing gravity:");
	Ball.setForce(Gravity, ToVector(98.0, 0.0, 0.0));
	fprintf(stderr, ".\n");
	while (X < 50.0) {
		printf("%s\t%g\r", Ball.name(), X);
		X = Ball.position().x();
	}
	printf("\n");
	
	
	return 0;
}