// earth.cc -- test out the fun universe.

#include <stdio.h>
#include "physics.h"
#include "math.h"

int main(void)
{
	universe Everything;
	
	printf("Setting damping coefficient:");
	Everything.setDampingCoeff(ToVector(0.0, 0.0, 5.0));
	printf(".\n");
	
	object_id Earth = Everything.add(5.93e24,
	                  ToVector(-6.37e6, 0.0 ,0.0));

	object_id Ball = Everything.add(10.0, ToVector(50.0, 0.0, 0.0));

	printf("Created:  Earth = %d, Ball = %d\n", Earth, Ball);
	printf("mass of the earth: %g\n", Everything.mass(Earth));
		
	scalar h = Everything.position(Ball).x();
	
	scalar* Output = Everything.acceleration(Ball).array();
	printf("a = (%g, %g, %g)\n", Output[0], Output[1], Output[2]);
	Everything.acceleration(Earth).array();
	printf("a = (%g, %g, %g)\n", Output[0], Output[1], Output[2]);

	
	Everything.calculateDamping();
	
	scalar initial = Everything.time();
	int i = 0;
	while (h > 0.0) {
		Everything.position(Ball).array();
		//printf("s = (%g, %g, %g)\r", Output[0], Output[1], Output[2]);
//		Everything.acceleration(Ball).array();
//		printf("a = (%.3f,\t%.3f,\t%.3f)\r", Output[0],
//		       Output[1], Output[2]);
		h = Everything.position(Ball).x();
		i++;
	}
	scalar final = Everything.time();
	
	printf("\n");
	printf("%d loops in %g seconds.  %g loops/sec.\n", i, final - initial,
	       i / (final - initial));
	printf("Ideally, Newton says t = sqrt(2*s/a) = %g\n",
                sqrt(2*50.0/9.75131)); 	
	printf("W/ friction: t = %g\n", sqrt(2*50.0/9.25131));
	return 0;

}
