// gravitation.cc - testing out the new interaction classes

#include <stdio.h>
#include "physics.h"

int main(void)
{
	object Earth("earth", 5.93e24, ToVector(-6.37e6, 0.0 ,0.0));
	object Ball("ball", 10);
	
	interaction* Link = new gravitation (&Earth, &Ball);
	scalar old_T = Ball.time();

	vector a = Ball.acceleration();
		
	printf("a = (%g, %g, %g)\n", a.x(), a.y(), a.z());
	scalar X = Ball.position().x();
	while (X > -50.0) {
		X = Ball.position().x();
	}
	printf("t = %g\n", Ball.time() - old_T);
	
	return 0;
}
