/* cross-id.cc -- methods for keeping track of the different id # systems

        OK, here's the problem.  In XML, you give an object an id # just by
   typing it in.  RockSpace assigns ID numbers sequentially as the objects
   are created.  As a result, we can't make the id's have the same value.
   To get around this, we simply keep a table of equivalent id #s.  These
   methods access said table.
*/

#include "rs-xml.h"


object_id universe_xml_interface::rsId(int Xml_Id) const
{
	id_list* Here = _id_table;
	while (Here != NULL) {
		if (Here->XML_id == Xml_Id) {
			return Here->RS_id;
		}
		Here = Here->next;
	}
	
	return 0;

}

int universe_xml_interface::xmlId(object_id Rs_Id) const
{
	id_list* Here = _id_table;
	while (Here != NULL) {
		if (Here->RS_id == Rs_Id) {
			return Here->XML_id;
		}
		Here = Here->next;
	}
	
	return 0;
}