/* extract.cc -- general functions useful for grabbing information
      pertaining to RockSpace from the DOM
*/

#include "rs-xml.h"

#include <libxml/tree.h>

#include <stddef.h>
#include <string.h>
#include <stdlib.h>

vector Extract_Vector(xmlNode* Node)
{
	if (Node == NULL) {
		return ZERO_VECTOR;
	}

	scalar x = 0.0, y = 0.0, z = 0.0;
	
	xmlAttr* Attr = Node->properties;
	while (Attr != NULL) {
		if (   (strcmp((char*) Attr->name, "x") == 0)
		    || (strcmp((char*) Attr->name, "a") == 0)) {
			x = atof((char*) Attr->children->content);
		} else if (   (strcmp((char*) Attr->name, "y") == 0)
		           || (strcmp((char*) Attr->name, "b") == 0)) {
			y = atof((char*) Attr->children->content);
		} else if (   (strcmp((char*) Attr->name, "z") == 0)
		           || (strcmp((char*) Attr->name, "c") == 0)) {
			z = atof((char*) Attr->children->content);
		}
		
		Attr = Attr->next;
	}
	
	return ToVector(x, y, z);
}

char* Extract_Attr(xmlNode* Node, char* Name)
{
	if (Node == NULL) {
		return "";
	}
	xmlAttr* Attr = Node->properties;
	while (Attr != NULL) {
		if (strcmp((char*) Attr->name, Name) == 0) {
			return (char*) Attr->children->content;
		}
		Attr = Attr->next;
	}
	return "";
}

