/* universe_xml_interface.cc - constructors/destructors for RockSpace XML
   bindings.

*/

#include "rs-xml.h"
#include <stddef.h>


void Delete_Nodes(id_list* Here);

universe_xml_interface::universe_xml_interface(void)
{
	_doc = NULL;
	_root = NULL;
	_id_table = NULL;
	_uni = NULL;
}

universe_xml_interface::universe_xml_interface(char* Filename)
{
	_doc = NULL;
	_root = NULL;
	_id_table = NULL;
	_uni = NULL;
        load(Filename);
}

universe_xml_interface::universe_xml_interface(universe* Uni)
{
	_doc = NULL;
	_root = NULL;
	_id_table = NULL;
	_uni = NULL;
	input(Uni);
}

universe_xml_interface::~universe_xml_interface(void)
{
	// The question:  Which data structures should we delete?
	// Since we're intending to use this class as I/O for the universe,
	// we won't delete the universe.  However, the XML DOM tree will go
	// away.
	if (_doc != NULL) {
		xmlFreeDoc(_doc);
	}
	
	Delete_Nodes(_id_table);
	
	_doc = NULL;
	_root = NULL;
	_id_table = NULL;

	return;
}

void Delete_Nodes(id_list* Here)
{
	if (Here != NULL) {
		Delete_Nodes(Here->next);
		delete Here;
	}
}